/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mozilla Communicator client code, released
 * March 31, 1998.
 *
 * The Initial Developer of the Original Code is
 * Netscape Communications Corporation.
 * Portions created by the Initial Developer are Copyright (C) 1998-2001
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Joe Hewitt (hewitt@netscape.com)
 *   Pamela Greene (pamg.bugs@gmail.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/* ===== autocomplete.css =================================================
  == Styles used by the autocomplete widget.
  ======================================================================= */

@namespace url("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul");
@namespace html url("http://www.w3.org/1999/xhtml");

/* ::::: autocomplete ::::: */

textbox {
  cursor: default;
  padding: 0;
}

/* Used by autocomplete widgets that don't have an icon. Gross. -dwh */
textbox.padded {
  padding-top: 1px;
  padding-bottom: 1px;
  -moz-padding-start: 2px;
  -moz-padding-end: 0px;
}

.autocomplete-textbox-container {
  -moz-box-align: center;
}

.textbox-input-box {
  margin: 0 3px;
  -moz-box-align: center;
}

/* ::::: history button ::::: */

.autocomplete-history-dropmarker {
  -moz-appearance: none !important;
  height: 20px;
  margin: 0px;
  border-top: none !important;
  border-bottom: none !important;
  border-left: 1px solid !important;
  -moz-border-left-colors: ThreeDShadow !important;
  border-right: none !important;
  padding: 0 !important;
  list-style-image: url("chrome://global/skin/icons/autocomplete-dropmark-arrow.png") !important;
  -moz-image-region: rect(0px, 16px, 20px, 0px) !important;
}

.autocomplete-history-dropmarker[enablehistory="true"] {
  -moz-binding: url("chrome://global/skin/globalBindings.xml#history-dropmarker")
}

textbox[chromedir="rtl"] .autocomplete-history-dropmarker {
  border-left: none !important;
  border-right: 1px solid !important;
  -moz-border-right-colors: ThreeDShadow !important;
}

.autocomplete-history-dropmarker:hover {
  -moz-image-region: rect(0px, 32px, 20px, 16px) !important;
}

.autocomplete-history-dropmarker:active {
  -moz-image-region: rect(0px, 64px, 20px, 48px) !important;
}

.autocomplete-dropmarker-bkgnd-top {
  list-style-image: url("chrome://global/skin/icons/autocomplete-dropmark-bkgnd.png");
  -moz-image-region: rect(0px, 16px, 9px, 0px);
  height: 9px;
}

/* GTK does not stretch image regions properly, so use background images instead.
   See bugs 351764 and 254659. */
.autocomplete-dropmarker-bkgnd-mid-top {
  background-image: url("chrome://global/skin/icons/autocomplete-dropmark-bkgnd-mid-top.png");
  background-repeat: repeat;
  -moz-background-clip: padding;
}

.autocomplete-dropmarker-bkgnd-mid-bottom {
  background-image: url("chrome://global/skin/icons/autocomplete-dropmark-bkgnd-mid-bottom.png");
  background-repeat: repeat;
  -moz-background-clip: padding;
  list-style-image: none;
}

.autocomplete-dropmarker-bkgnd-bottom {
  list-style-image: url("chrome://global/skin/icons/autocomplete-dropmark-bkgnd.png");
  -moz-image-region: rect(11px, 16px, 20px, 0px);
  height: 9px;
}

.autocomplete-history-dropmarker:hover .autocomplete-dropmarker-bkgnd-top {
  -moz-image-region: rect(0px, 32px, 9px, 16px);
  height: 9px;
}

.autocomplete-history-dropmarker:hover .autocomplete-dropmarker-bkgnd-mid-top {
  background-position: -16px 0px;
}

.autocomplete-history-dropmarker:hover .autocomplete-dropmarker-bkgnd-mid-bottom {
  background-position: -16px 0px;
}

.autocomplete-history-dropmarker:hover .autocomplete-dropmarker-bkgnd-bottom {
  -moz-image-region: rect(11px, 32px, 20px, 16px);
  height: 9px;
}

.autocomplete-history-dropmarker:hover:active .autocomplete-dropmarker-bkgnd-top {
  -moz-image-region: rect(0px, 64px, 9px, 48px);
  height: 9px;
}

.autocomplete-history-dropmarker:hover:active .autocomplete-dropmarker-bkgnd-mid-top {
  background-position: -48px 0px;
}

.autocomplete-history-dropmarker:hover:active .autocomplete-dropmarker-bkgnd-mid-bottom {
  background-position: -48px 0px;
}

.autocomplete-history-dropmarker:hover:active .autocomplete-dropmarker-bkgnd-bottom {
  -moz-image-region: rect(11px, 64px, 20px, 48px);
  height: 9px;
}

/* ::::: autocomplete popups ::::: */

panel[type="autocomplete"],
.autocomplete-history-popup {
  -moz-appearance: none;
  border-width: 1px;
  -moz-border-top-colors: ThreeDDarkShadow;
  -moz-border-right-colors: ThreeDDarkShadow;
  -moz-border-bottom-colors: ThreeDDarkShadow;
  -moz-border-left-colors: ThreeDDarkShadow;
  padding: 0;
  background-color: -moz-Field !important;
}

.autocomplete-history-popup {
  max-height: 180px;
}

/* ::::: tree ::::: */

.autocomplete-tree {
  -moz-appearance: none !important;
  border: none !important;
  background-color: transparent !important;
}

.autocomplete-treecol {
  -moz-appearance: none !important;
  margin: 0 !important;
  border: none !important;
  padding: 0 !important;
}

.autocomplete-treebody::-moz-tree-cell-text {
  -moz-padding-start: 8px;
}

treechildren.autocomplete-treebody::-moz-tree-row(selected) {
 background-color: Highlight;
}

treechildren.autocomplete-treebody::-moz-tree-cell-text(selected) {
  color: HighlightText !important;
}

/* ::::: textboxes inside toolbarpaletteitems ::::: */

toolbarpaletteitem > toolbaritem > textbox > hbox > hbox > html|*.textbox-input {
  visibility: hidden;
}

toolbarpaletteitem > toolbaritem > * > textbox > hbox > hbox > html|*.textbox-input {
  visibility: hidden;
}

